
.include "1200def.inc"

.equ	Strobe	= PD2		              ; Strobe 4094
.equ	D4094	= PD4		               ; Daten fr 4094
.equ	CLK	= PD5		                 ; 4094 Clock


.def	delay2	= r27
.def	temp1	= r25
.def	temp2	= r26
;**************************************************************************
;*
;* 		Schieberegister CD4094 laden ohne SPI-Controller
;*
;**************************************************************************


schiebe:
			cli
	  cbi	Portd,Strobe	             ; Strobe auf Low
	  cbi	Portd,clk	                ; clk auf low
	  ldi	temp2,8		                 ; 8Bit Schieben
putchar0: 
	  lsl	temp1
	  brcs	putchar1	                ;If carry set	
	  cbi	PORTD,D4094	              ;    send a '0'	
	  rjmp	putchar2	                ;else	
putchar1:
	  sbi	PORTD,D4094	              ;    send a '1'	
	  nop
putchar2:
	  sbi	Portd,clk	                ; Clock High
	  ldi	delay2,0
del1:	
   dec	delay2	
	  brne	del1	
	  cbi	Portd,clk	                ; Clock Low
			                              ; Get next bit	
	  dec	temp2		                   ; If not all bit sent	
	  brne	putchar0	                ;   send next	
				                             ; else
	  sbi	Portd,Strobe	             ; Strobe High
	  ldi	delay2,0                  ; wait
del2:	
   dec	delay2	
	  brne	del2		
	  cbi	Portd,Strobe	             ; Strobe Low Daten OK
	  sei
	  ret			                        ; return